#
# Module manifest for module 'SharePointDsc'
#
# Generated by: Microsoft Corporation
#
# Generated on: 20/06/2018
#

@{

# Script module or binary module file associated with this manifest.
# RootModule = ''

# Version number of this module.
ModuleVersion = '3.2.0.0'

# ID used to uniquely identify this module
GUID = '6c1176a0-4fac-4134-8ca2-3fa8a21a7b90'

# Author of this module
Author = 'Microsoft Corporation'

# Company or vendor of this module
CompanyName = 'Microsoft Corporation'

# Copyright statement for this module
Copyright = '(c) 2015-2018 Microsoft Corporation. All rights reserved.'

# Description of the functionality provided by this module
Description = 'This DSC module is used to deploy and configure SharePoint Server 2013, 2016 and 2019, and covers a wide range of areas including web apps, service apps and farm configuration.'

# Minimum version of the Windows PowerShell engine required by this module
PowerShellVersion = '4.0'

# Name of the Windows PowerShell host required by this module
# PowerShellHostName = ''

# Minimum version of the Windows PowerShell host required by this module
# PowerShellHostVersion = ''

# Minimum version of Microsoft .NET Framework required by this module
# DotNetFrameworkVersion = ''

# Minimum version of the common language runtime (CLR) required by this module
# CLRVersion = ''

# Processor architecture (None, X86, Amd64) required by this module
# ProcessorArchitecture = ''

# Modules that must be imported into the global environment prior to importing this module
# RequiredModules = @()

# Assemblies that must be loaded prior to importing this module
# RequiredAssemblies = @()

# Script files (.ps1) that are run in the caller's environment prior to importing this module.
# ScriptsToProcess = @()

# Type files (.ps1xml) to be loaded when importing this module
# TypesToProcess = @()

# Format files (.ps1xml) to be loaded when importing this module
# FormatsToProcess = @()

# Modules to import as nested modules of the module specified in RootModule/ModuleToProcess
NestedModules = @("modules\SharePointDsc.Util\SharePointDsc.Util.psm1")

# Functions to export from this module
#FunctionsToExport = '*'

# Cmdlets to export from this module
CmdletsToExport = @("Invoke-SPDSCCommand",
                    "Get-SPDSCInstalledProductVersion",
                    "Get-SPDSCContentService",
                    "Rename-SPDSCParamValue",
                    "Add-SPDSCUserToLocalAdmin",
                    "Remove-SPDSCUserToLocalAdmin",
                    "Test-SPDSCObjectHasProperty",
                    "Test-SPDSCRunAsCredential",
                    "Test-SPDSCUserIsLocalAdmin",
                    "Test-SPDscParameterState",
                    "Test-SPDSCIsADUser",
                    "Test-SPDSCRunningAsFarmAccount",
                    "Set-SPDscObjectPropertyIfValuePresent",
                    "Get-SPDSCUserProfileSubTypeManager",
                    "Get-SPDscOSVersion",
                    "Get-SPDSCRegistryKey",
                    "Resolve-SPDscSecurityIdentifier",
                    "Get-SPDscFarmProductsInfo",
                    "Get-SPDscFarmVersionInfo",
                    "Convert-SPDscADGroupIDToName",
                    "Convert-SPDscADGroupNameToID")

# Variables to export from this module
#VariablesToExport = '*'

# Aliases to export from this module
#AliasesToExport = '*'

# List of all modules packaged with this module
# ModuleList = @()

# List of all files packaged with this module
# FileList = @()

# HelpInfo URI of this module
# HelpInfoURI = ''

# Default prefix for commands exported from this module. Override the default prefix using Import-Module -prefix.
# DefaultCommandPrefix = ''

# Private data to pass to the module specified in RootModule/ModuleToProcess. This may also contain a PSData hashtable with additional module metadata used by PowerShell.
PrivateData = @{

    PSData = @{

        # Tags applied to this module. These help with module discovery in online galleries.
        Tags = @('DesiredStateConfiguration', 'DSC', 'DSCResourceKit', 'DSCResource')

        # A URL to the license for this module.
        LicenseUri = 'https://github.com/PowerShell/SharePointDsc/blob/master/LICENSE'

        # A URL to the main website for this project.
        ProjectUri = 'https://github.com/PowerShell/SharePointDsc'

        # A URL to an icon representing this module.
        # IconUri = ''

        # ReleaseNotes of this module
        ReleaseNotes = "
      * Changes to SharePointDsc unit testing
        * Implemented Strict Mode version 1 for all code run during unit tests.
        * Changed InstallAccount into PSDscRunAsCredential parameter in examples
      * SPAuthenticationRealm
        * New resource for setting farm authentication realm
      * SPConfigWizard
        * Updated PSConfig parameters according recommendations in blog post of
          Stefan Gossner
      * SPDistributedCacheService
        * Fixed exception on Stop-SPServiceInstance with SharePoint 2019
      * SPFarm
        * Improved logging
        * Added ability to manage the Developer Dashboard settings
      * SPFarmSolution
        * Fixed issue where uninstalling a solution would not work as expected if it
          contained web application resources.
      * SPIncomingEmailSettings
        * New resource for configuring incoming email settings
      * SPInstallPrereqs
        * Improved logging
        * Corrected detection for Windows Server 2019
        * Corrected support for Windows Server 2019 for SharePoint 2016
      * SPProductUpgrade
        * Fixed issue where upgrading SP2013 would not properly detect the installed
          version
        * Fixed issue where the localized SharePoint 2019 CU was detected as a
          Service Pack for a Language Pack
      * SPSearchAuthorativePage
        * Fixed issue where modifying search query would not target the correct
          search application
      * SPSearchResultSource
        * Updated resource to allow localized ProviderTypes
      * SPServiceAppSecurity
        * Updated resource to allow localized permission levels
      * SPServiceInstance
        * Added -All switch to resolve 'Unable to locate service application' in SP2013
      * SPSite
        * Improved logging
      * SPUserProfileProperty
        * Fix user profile property mappings does not work
      * SPUserProfileServiceApp
        * Added warning message when MySiteHostLocation is not specified. This is
          currently not required, which results in an error. Will be corrected in
          SPDsc v4.0 (is a breaking change).
      * SPUserProfileSyncConnection
        * Fixed issue where test resource never would return true for any configurations
          on SharePoint 2016/2019
        * Fixed issue where updating existing connection never would work for any
          configurations on SharePoint 2016/2019
        * Updated documentation to reflect that Fore will not impact configurations for
          SharePoint 2016/2019. Updated the test method accordingly.
      * SPUserProfileSyncService
        * Fixed issue where failure to configure the sync service would not throw error
      * SPWebAppPeoplePickerSettings
        * Converted password for access account to secure string. Previsouly
          the resource would fail setting the password and an exeption was thrown that
          printed the password in clear text.
      * SPWebAppPolicy
        * Fixed issue where parameter MembersToExclude did not work as expected
      * SPWorkflowService
        * Added support for specifying scope name.
        * Added support for detecting incorrect configuration for scope name and
          WorkflowHostUri
"
    } # End of PSData hashtable

} # End of PrivateData hashtable
}

